// Progress_sample.cpp : main source file for Progress_sample.exe
//

#include "stdafx.h"

#include "resource.h"

#include "ProgressDlg.h"

CAppModule _Module;

struct ThreadParams
{
	int foo;
	int bar;
};

//      
DWORD WINAPI ThreadFunc (void* params)
 {
	 //    ProgressParam<ThreadParams>,
	 //     IProgress   
     ProgressParam<ThreadParams> *pp = (ProgressParam<ThreadParams>*)params;

	 //  ,         
	 ThreadParams* threadParams = (ThreadParams*)pp->pParams;

	 //     
     pp->pProgress->SetProgressRange(0, 100, 0);

	 //   
     for (int i = 0; i < 100; ++i)
     {
         Sleep (100);
         pp->pProgress->SetProgress(i + 1);
     }
     return 0;
 }

int Run(LPTSTR /*lpstrCmdLine*/ = NULL, int nCmdShow = SW_SHOWDEFAULT)
{
	ThreadParams params;
	params.foo = 10;
	params.bar = 20;

	CProgressDlg <ThreadParams, IDD_PROGRESS, IDC_TIME > dlg (ThreadFunc, &params, _T(", ") );
	dlg.Start();
	return 0;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
	HRESULT hRes = ::CoInitialize(NULL);
// If you are running on NT 4.0 or higher you can use the following call instead to 
// make the EXE free threaded. This means that calls come in on a random RPC thread.
//	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT(SUCCEEDED(hRes));

	// this resolves ATL window thunking problem when Microsoft Layer for Unicode (MSLU) is used
	::DefWindowProc(NULL, 0, 0, 0L);

	AtlInitCommonControls(ICC_BAR_CLASSES);	// add flags to support other controls

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));

	int nRet = Run(lpstrCmdLine, nCmdShow);

	_Module.Term();
	::CoUninitialize();

	return nRet;
}
